/*****************************************************************************/
/*           Routines d'initialisation  et calculs              J.Senlis 2005*/
/*****************************************************************************/
#include "p30f6014.h"
#include "float.h"
#include "math.h"
#include "stdio.h"
#include "stdlib.h"

#define PI 3.141592654
#define  Max 1025			// coeff. maxi
//*************les variables globales********************************************
int _YBSS(2) A[Max]; 		// coef.
int _XBSS(2) X[Max] ;  	// les echantillons
int A0[Max];
double M=500;               // nombre de coef-1.
unsigned int MM=499;		// nombre de coef-2	
unsigned int WW10;			// pour sauvegarder le registre W10 
unsigned int WW8;			// pour sauvegarder W8
double fe=44100;			// f echantillonnage
double fpb=10300;			// f de coupure passe bas
double fcy=4*7372800;		// PLL 16

//**************Les fonctions*****************************************************
void calcul_pb(double freq)
	{int i,n;
	double s=0,f,b=32768.0;
	f=freq/fe;n=M/2;
	for (i=0;i<n;i++) {A[i]=(b*(sin(2*PI*f*(i-n))))/(PI*(i-n));} 
	A[n]=2*f*b;	
	for (i=n+1;i<=M;i++){ A[i]=(b*(sin(2*PI*f*(i-n))))/(PI*(i-n));} 
	for (i=0;i<=M;i++) A[i]=A[i]*((0.54+(1-0.54)*cos(2*PI*(i-M/2)/(M+1))));
	}

void init_dsp()
	{
	XMODSRT=(unsigned int) X;
	XMODEND=(unsigned int) X+2*(int)M+1;
	YMODSRT=(unsigned int) A;
	YMODEND=(unsigned int) A+2*(int)M+1;
	WW10=YMODSRT;
	WW8=XMODSRT;
	CORCON=CORCON|0x00A0;//signed sat  
	CORCON=CORCON&0xfffC;//shift unbiass
	MODCON=0xCFA8;
	}

void adc_on()
	{asm("disi #20");
	asm("bclr IFS0,#11");
	asm("bset IEC0,#11");
	}

void adc_off()
	{asm("disi #20");
	T3CON=0x0000;
	asm("bclr IEC0,#11");
	}

void init_adc(void)
	{asm("disi #100");
	TRISD=0x0000;
	T3CON=0x8000;
	PR3=(unsigned int)(fcy/fe); 
	ADPCFG=0;
	ADCON2 = 0x0000; 	//pas de scan
	ADCON3 = 0x010A; 	//1Tad Tad=11Tcy/2
	ADCHS = 7;  	   	//Ch7
	ADCSSL=0;		
	ADCON1 = 0x8346;  	//8341 signedfrac 8146 signedInt
	asm("bset ADCON1,#15");
	asm("bset IPC2,#12");
	asm("bset IPC2,#13");
	asm("bset IPC2,#14");
	asm("bclr IFS0,#11") ;
	asm("bset IEC0,#11") ;
	}

void initialisation()
	{adc_off();
	MM= (unsigned int)(M-1);
	calcul_pb(fpb);
	init_dsp();
	init_adc();
	}
	                           
void affiche_choix(double *f)
	{envoi_chaine("A Z E R T pour augmenter +1 +10 +100 +1000 +10000\n\r");
	 envoi_chaine("W X C V  pour diminuer  -1 -10 -100 -1000 -10000\n\r");
	 envoi_chaine(" Q ou ESC pour quitter\n\r");
	 envoi_chaine("Valeur = \n\r");envoi_long_dec((long int)*f);envoi_chaine(" \n\r");
	}

void modif_freq(double *f,char cc)
	{
	switch(cc)
			{case 'A' :*f+=1; break;
			case 'W' :*f-=1; break;
			case 'Z' :*f+=10; break;
			case 'X' :*f-=10; break;
			case 'E' :*f+=100; break;
			case 'C' :*f-=100; break;
			case 'R' :*f+=1000; break;
			case 'V' :*f-=1000; break;
			case 'T' :*f+=10000; break;
			case 'B' :*f-=10000; break;

			} 
	envoi_chaine("\rValeur = ");envoi_long_dec((long int)*f);envoi_chaine("      \r");
	initialisation();
	}

void freqECH(void)
	{char c=' ';
	affiche_choix(&fe);
	while ((c!='Q')&&(c!=27))
		{c=toupper(lit_char());modif_freq(&fe,c);
		PR3=(unsigned int)(fcy/fe);
		}
	envoi_menu();
	}

void nbreCOEFS(void)
	{char c=' ';
	affiche_choix(&M);
	while ((c!='Q')&&(c!=27))
		{c=toupper(lit_char());modif_freq(&M,c);
		}
	envoi_menu();
	}

void freqPB(void)
	{char c=' ';
	affiche_choix(&fpb);
	while ((c!='Q')&&(c!=27))
		{c=toupper(lit_char());modif_freq(&fpb,c);
		}
	envoi_menu();
	}

/**************La routine de traitement de l'interruption fin de conversion************************/

void __attribute__((__interrupt__,__shadow__)) _ADCInterrupt(void)
{	asm ("push.d W0");				//sauvegarde des registres utiliss 
	asm ("push.d W4");
	asm ("push.d W8");
	asm ("push.d W10");
	asm("push RCOUNT");
	asm("mov _MM,W1");				//initialisation des pointeurs de buffer 
	asm("mov _WW10,W10");		
	asm("mov _WW8,W8");
	asm("mov ADCBUF0,W0");  		//l'entre analogique Xn est stoche dans le buffer_X	
	asm("mov W0,[W8]");		
	asm("nop");
	asm("clr A,[W8],W4,[W10],W5"); 	//Dbut du calcul de Yn 
	asm("repeat W1"); 				// ech-2 ==ech+1 fois
	asm("mac W4*W5,A,[W8]+=2,W4,[W10]+=2,W5");
	asm("mac W4*W5,A,[W8],W4,[W10]+=2,W5");	//Fin du calcul
	asm("sac.r a,#7,W0");				 	//Sauvegarde de Yn avec dcalage
	asm("add #0x80,W0");				 	//offset
	asm("mov W0,PORTD");				 	//Sortie sur le portD
	asm("mov W10,_WW10");				 	//Sauvegarde des pointeurs de buffers 	
	asm("mov W8,_WW8");	
	asm("pop RCOUNT");						//Restauration des registres utiliss
	asm ("pop.d W10");
	asm ("pop.d W8");
	asm ("pop.d W4");
	asm ("pop.d W0");
	asm("bclr IFS0,#11") ;					//acquitement de l'interruption
}
